<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Task 66 Province District Ward</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<body class="hold-transition sidebar-mini">
<!-- Site wrapper -->
<div class="wrapper">
  <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="index3.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Contact</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">DevCamp 120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">LinhLT</a>
        </div>
      </div>

      <!-- SidebarSearch Form -->
      <div class="form-inline">
        <div class="input-group" data-widget="sidebar-search">
          <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
          <div class="input-group-append">
            <button class="btn btn-sidebar">
              <i class="fas fa-search fa-fw"></i>
            </button>
          </div>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="province.select.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Province Select</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="province.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Province CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="district.crud.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>District CRUD</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="ward.crud.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Ward CRUD</p>
                </a>
              </li>
            </ul>
          </li>
          
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Province - District - Ward Filter</h1>
          </div>
          
        </div>
      </div><!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container">
        <h2 style="text-align: center;">Quận Huyện CRUD</h2>
        
        <form id="inputform01" class="jumbotron container">
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="district-name">Tên</label>
            </div>
            <div class="col-sm-3">
              <input id="input-name" name="district-name" class="form-control">
              
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="district-prefix">Quận Huyện</label>
            </div>
            <div class="col-sm-3">
              <select id="select-prefix" name="district-prefix" class="form-control">
                <option>Quận</option>
                <option>Huyện</option>
              </select>
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-3">
              <label for="province">Tỉnh thành phố</label>
            </div>
            <div class="col-sm-3">
              <select id="province-select" name="province" class="form-control">
              </select>
            </div>
          </div>
          
          <div class="row pull-right">
            
            <div class="col-sm-1">
              <input type="button" value="Create" class="btn btn-info" id="btn-create-district">
            </div>
            <div class="col-sm-1">
              <input type="button" value="Update" class="btn btn-warning" id="btn-update-district">
            </div>
            <div class="col-sm-1">
              <input type="button" value="Delete" class="btn btn-danger" id="btn-delete-district">
            </div>
            <div class="col-sm-1">
              <input type="button" value="Cancel" class="btn btn-secondary" id="btn-cancel">
            </div>
            <div class="col-sm-8">
            </div>
          </div>
        </form>
        <table class="table table-bordered table-striped table-hover" id="user-table">
          <thead>
            <tr>
              <th>STT</th>
              <th>Tên</th>
              <th>Quận Huyện</th>
            </tr>
        </table>
      </div>

    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->

  <footer class="main-footer">
    <div class="float-right d-none d-sm-block">
      <b>Version</b> 1.0.0
    </div>
    <strong>Copyright &copy; 2023 <a href="">DevCamp 120</a>.</strong> All rights reserved.
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // Biến toàn cục để lưu trữ id district đang đc update or delete. Mặc định = 0;
  var gDistrictId = 0;
  const gBASE_URL = "http://localhost:8080/district";
  const gCONTENT_TYPE = "application/json;charset=UTF-8";

  $(document).ready(function(){
    var table = $("#user-table").DataTable({
      "columns": [
        {"data":"id"},
        {"data":"name"},
        {"data":"prefix"},
      ]
    })
    $.ajax({
      url: gBASE_URL + "/all",
      type: "GET",
      dataType: "json",
      success: function(res){
        console.log(res);
        table.clear();
        table.rows.add(res);
        table.draw();
      },
      error: function(err){
        console.log(err.responseText);
      }
    })
      
  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $("#user-table").on("click", "tr", function(){
		onRowClick(this);
	})
	//task 2 - Update district: add event to save data button
	$("#btn-update-district").on("click",function(){
		onUpdateButtonClick();
	});
	//task 3 - Create new district
	$("#btn-create-district").on("click",function(){
		onCreateButtonClick();
	});
	//task 4 - Delete district selected
	$("#btn-delete-district").on("click",function(){
		onDeleteButtonClick();
	});
  
    
  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  //hàm xử lý sự kiện click row
	function onRowClick(paramRow){
		gDistrictId = $(paramRow).find("td:eq(0)").html();
		console.log("District id of selected row: " + gDistrictId);
		//lấy thông tin district của row được click và hiển thị lên form
		var vDistrict = callApiGetDistrictById(gDistrictId);
	};
  //hàm xử lý sự kiện nút save data
	function onUpdateButtonClick(){
		//khai báo district obj
		var vDistrictObj = {
			name: "",
      prefix:"",
			province: -1,
		}
		// B1: Thu thập dữ liệu
		getUpdateDistrictData(vDistrictObj);
		// B2: Validate update
		var vIsDistrictValid = validateDistrictData(vDistrictObj);
    	if (vIsDistrictValid){
			// B3: update district
			$.ajax({
				url: gBASE_URL + "/update/" + gDistrictId,
				type: "PUT",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vDistrictObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleUpdateDistrictSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	
	//hàm xử lý sự kiện nút thêm district
	function onCreateButtonClick(){
		//khai báo district obj
		var vDistrictObj = {
			name: "",
      prefix:"",
			province: -1,
		}
		// B1: Thu thập dữ liệu
		getUpdateDistrictData(vDistrictObj);
		// B2: Validate data
		var vIsDistrictValid = validateDistrictData(vDistrictObj);
    	if (vIsDistrictValid){
			// B3: create voucher
			$.ajax({
				url: gBASE_URL + "/create/" + vDistrictObj.province,
				type: "POST",
				contentType: gCONTENT_TYPE,
				data: JSON.stringify(vDistrictObj),
				success: function(res){
					// B4: xử lý hiển thị
					handleCreateDistrictSuccess();
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
	}
	//hàm xử lý sự kiện nút xóa district được chọn và hiển thị trên form
	function onDeleteButtonClick(){
    //b1: thu thập dữ liệu
    //b2: validate
    //b3: thực hiện xóa - gọi API
      $.ajax({
        url: gBASE_URL + "/delete/" + gDistrictId,
        type: "DELETE",
        success: function(paramRes) {
          handleDeleteDistrictSuccess();
        },
        error: function(paramErr) {
          alert("Xóa dữ liệu không thành công");
        }
      });
	}

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  //Get data province để hiển thị lên form select
    $.ajax({
        url: "http://localhost:8080/province/all",
        method: "GET",
        success: function(pObjRes) {
          console.log(pObjRes);
          loadDataToProvinceSelect(pObjRes);
        },
        error: function(paramErr) {
          console.log(paramErr.responseText);
        }
      });

      var gProvinceSelectElement = $("#province-select");

      function loadDataToProvinceSelect(pProvinceList) {
        for (let i = 0; i < pProvinceList.length; i++) {
          var bProvinceOption = $("<option/>");
          bProvinceOption.prop("value", pProvinceList[i].id);
          bProvinceOption.prop("text", pProvinceList[i].name);
          gProvinceSelectElement.append(bProvinceOption);
        };
      }

  });

  //hàm gọi API lấy thông tin của dòng được chọn
	function callApiGetDistrictById(paramId){
		$.ajax({
			url: gBASE_URL + "/detail/" + paramId,
			type: "GET",
			dataType: "json",
			success: function(res){
				console.log(res);
				displayDistrictData(res);
			},
			error: function(err){
				console.log(err.responseText);
			}
		})
	}
	//hàm hiển thị thông tin của dòng được click
	function displayDistrictData(paramDistrict){
		$("#input-name").val(paramDistrict.name);
		$("#select-prefix").val(paramDistrict.prefix); 
		$("#province-select").val(paramDistrict.province); 
	}
  // hàm thu thập dữ liệu để update district
	function getUpdateDistrictData(paramDistrictObj) {
		paramDistrictObj.name =$("#input-name").val().trim();
    paramDistrictObj.prefix = $("#select-prefix").val().trim(); 
		paramDistrictObj.province = parseInt($("#province-select").val()); 
	}

	// hàm validate data
	function validateDistrictData(paramDistrictObj) {
		if (paramDistrictObj.name === "") {
		alert("Cần nhập tên");
		return false;
		}
		if (paramDistrictObj.province == null) {
		alert("Cần nhập thông tin Tỉnh Thành phố");
		return false;
		}
		return true;
	}
	
	//hiển thị cập nhật thành công
	function handleUpdateDistrictSuccess(){
		alert("Sửa quận/huyện có id: " + gDistrictId + " thành công!");
	};
	//hiển thị thêm quận/huyện thành công
	function handleCreateDistrictSuccess(){
		alert("Thêm quận/huyện thành công!");
	};
	//hiển thị xóa thành công
	function handleDeleteDistrictSuccess(){
		alert("Xóa quận/huyện có id: " + gDistrictId + " thành công!");
	};
</script>
</body>
</html>
